local TimeSinceLastUpdate = 0
local TimeSinceLastPetAttack = 0
local TimeSinceLastPlayerAttack = 0
local TimeSinceLastScreenIconUpdate = 0
local MessageSent = false
local TipPlayDead = false
local Growler_PetCalled = 0
local btnSize = 32
local siSize = 100

local prnt
local tablesize
local PlayerHasSpell
local GetSpellIcon
local SpellIsReady
local IsSpellActive
local UnitHasBuff
local GrowlerNotifyGroup
local GrowlerCheckCombatLogEvent
local GrowlerBtn_MouseDown
local GrowlerBtn_DragStart
local GrowlerBtn_DragStop
local GrowlerShow
local GrowlerHide
local InitiateDB
local ResetDB
local GrowlerSetup

prnt = function(input)
	print("|cFF00FF00Output: |cFFFF0000" .. tostring(input) .. "|cFF00FF00 Type: |cFFFF0000" .. type(input))
end

tablesize = function(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end

PlayerHasSpell = function(spell)
	local spellType,spellID = GetSpellBookItemInfo(spell)
	return (GetSpellBookItemInfo(spell) ~= nil)
end

GetSpellIcon = function(spellID)
	local _,_,icon = GetSpellInfo(spellID)
	return icon
end

SpellIsReady = function(spell,book)	
	local start,cooldown,_ = GetSpellCooldown(spell)
	return (start == 0)
end

IsSpellActive = function(spell,book)
	if book == nil or book == 1 then
		book = "BOOKTYPE_SPELL"
	elseif book == 2 then
		book = "BOOKTYPE_PET"
	end
	_, _, enabled = GetSpellCooldown(spell, book)
	return enabled
end

UnitHasBuff = function(unit,buff)
	return (UnitAura(unit,buff) ~= nil)
end

GrowlerNotifyGroup = function(unit, spellName, rank, lineID, spellID)
	if not MessageSent and GrowlerDB.options.notifygroup and IsInGroup() and spellID == 2649 and (UnitPlayerOrPetInRaid(unit) or UnitPlayerOrPetInParty(unit)) then
		local groupType = "PARTY"
		if IsInRaid() then groupType = "RAID" end
		SendChatMessage("{{Growler alert :: A hunter in the group has not turned off growl -- Download the addon to help manage your pets.}}",groupType)
		MessageSent = true
	end
end

GrowlerCheckCombatLogEvent = function(timestamp,event,_,sourceGUID,sourceName,sourceFlags,sourceRaidFlags,destGUID,destName,destFlags,destRaidFlags,spellID,spellName)
	if tostring(sourceGUID) == UnitGUID("pet") and event == "SWING_DAMAGE" then
		TimeSinceLastPetAttack = 0
	elseif tostring(sourceGUID) == UnitGUID("player") and (event == "RANGE_DAMAGE" or event == "SPELL_DAMAGE") then
		TimeSinceLastPlayerAttack = 0
	end
end

InitiateDB = function()
	Growler.DefaultDB = {
		["options"] = {
			["enable"] = true,
			["sound"] = true,
			["nonparty"] = true,
			["notifygroup"] = true,
			["screenicons"] = true,
			["enable_growl"] = true,
			["enable_call"] = true,
			["enable_revive"] = true,
			["enable_mend"] = true,
			["mend_threshhold"] = 0.5,
			["enable_playdead"] = true,
			["enable_wakeup"] = true,
			["enable_passive"] = true,
			["enable_assist"] = true,
			["savepos"] = true,
			["pos_x"] = 0,
			["pos_y"] = -150,
			["point"] = "CENTER",
			["relativeto"] = World,
			["relativepoint"] = "CENTER",
			["activepetslot"] = 0
		}
	}
	if GrowlerDB == nil then
		GrowlerDB = Growler.DefaultDB
	else
		for k,v in  pairs(Growler.DefaultDB.options) do
			if GrowlerDB.options[k] == nil then
				GrowlerDB.options[k] = v
			end
		end
	end
end

GrowlerSetup = function()
	Growler.btn = {}
	
	Growler.msg = function(msg,warning)
		local color1 = "|cFFff4433"
		local color2 = "|cFFaa8822"
		print(color1 .. "{{" .. color2 .. "Growler " .. color1 .. "::" .. color2 .. " " .. msg .. color1 .. "}}")
		if warning then PlaySoundKitID(47355) end
		--if warning then PlaySoundKitID(34040) end
	end
	
	Growler.GetActivePetSlot = function()
		local curName,_ = UnitName("pet")
		local curFamily = UnitCreatureFamily("pet")
		local curIcon = GetPetIcon()
		local activepetslot = 0
		for i=1,5 do
			local petIcon, petName, _, petType, _ = GetStablePetInfo(i)
			if petIcon ~= nil and petIcon == curIcon and petName == curName and petType == curFamily then
				activepetslot = i
			end
		end
		return activepetslot
	end
				
	Growler.SetActivePetSlot = function(load)
		if not InCombatLockdown() then
			local curName,_ = UnitName("pet")
			local curFamily = UnitCreatureFamily("pet")
			local curIcon = GetPetIcon()
			local activepetslot = 0
			if load ~= nil then
				activepetslot = GrowlerDB.options.activepetslot
			else
				if curName ~= nil then
					for i=1,5 do
						local petIcon, petName, _, petType, _ = GetStablePetInfo(i)
						if petIcon ~= nil and petIcon == curIcon and petName == curName and petType == curFamily then
							activepetslot = i
						end
					end
					
					GrowlerDB.options.activepetslot = activepetslot
					
					Growler.btn.call:SetAttribute("macrotext1","/cast [pet] Revive Pet\n/castsequence [nopet] reset=3 Call Pet " .. tostring(activepetslot) .. ", Revive Pet")
					Growler.msg("Active pet slot(" .. activepetslot .. ") saved.")
					PlaySoundKitID(13827)
				else
					Growler.msg("Summon a pet to save that as your active slot.",true)
				end
			end
			if activepetslot == 0 and load then
				Growler.msg("You do not have an active pet slot saved. Summon a pet and click the save button.")
			end
		else
			if not load then
				Growler.msg("You cannot change your active pet in combat.",true)
			end
		end
	end
	
	Growler.SetTexture = function(texturepath,frame)
		frame.texture = frame:CreateTexture(nil,"BACKGROUND")
		frame.texture:SetTexture(texturepath)
		frame.texture:SetAllPoints(frame)
	end
	
	-- Growler.CreateBarButton = function(name,width,height,up,down,disabled,clickHandler,updateHandler)
		-- Growler.bar[name] = CreateFrame("BUTTON","GrowlerBar_" .. name,Growler.bar)
		-- Growler.bar[name]:SetSize(16,32)
		-- Growler.bar[name]:SetPoint("RIGHT",Growler.bar,"RIGHT",-10,0)
		-- Growler.bar[name].texture_up = "Interface\\BUTTONS\\UI-Button-KeyRing"
		-- Growler.bar[name].texture_down = "Interface\\BUTTONS\\UI-Button-KeyRing-Down"
		-- Growler.bar[name].texture_disabled = ""
		-- Growler.SetTexture(Growler.bar[name].texture_down,Growler.bar[name])
		-- Growler.bar[name].texture:SetPoint("BOTTOMRIGHT",Growler.bar[name],"BOTTOMRIGHT",16,-23)
		-- Growler.bar[name].texture:SetPoint("TOPLEFT",Growler.bar[name],"TOPLEFT",0,2)
		-- Growler.bar[name]:RegisterForClicks("LeftButtonUp")
		-- Growler.bar[name]:SetScript("OnMouseUp",clickHandler)
		-- Growler.bar[name].update = updateHandler
	-- end
	
	Growler.CreateBar = function()
		Growler.bar = CreateFrame("BUTTON", "GrowlerBar", UIParent)
		Growler.bar:SetSize(200,btnSize+10)
		Growler.bar.movable = false
		Growler.bar:SetMovable(false)
		Growler.bar:SetClampedToScreen(true)
		Growler.bar:RegisterForClicks("AnyDown")
		Growler.bar:SetScript("OnMouseDown", function(self,button) Growler.bar.MouseDown(self,button) end)
		Growler.bar:RegisterForDrag("LeftButton")
		Growler.bar:SetScript("OnDragStart", function(self) Growler.bar.DragStart(self) end)
		Growler.bar:SetScript("OnDragStop", function(self) Growler.bar.DragStop(self) end)
		Growler.bar.DragStart = function(self)
			if Growler.bar.movable then
				Growler.bar:SetMovable(true)
				Growler.bar:StartMoving()
			end
		end
		Growler.bar.DragStop = function(self)
			Growler.bar:StopMovingOrSizing()
			Growler.bar:SetMovable(false)
			Growler.bar.SavePos()
		end
		Growler.bar.MouseDown = function(self, button)
			if button == "RightButton" then
			elseif button == "MiddleButton" then
			end
		end
		local backdrop = {
		  bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
		  edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
		  tile = true,
		  tileSize = 32,
		  edgeSize = 16,
		  insets = {
			left = 5,
			right = 5,
			top = 5,
			bottom = 5
		  }
		}
		Growler.bar:SetBackdrop(backdrop)
		Growler.bar:SetBackdropColor(0,0,0,1)
		Growler.bar:SetBackdropBorderColor(1,1,1,1)		
		
		Growler.bar.resetbtn = CreateFrame("BUTTON","GrowlerBar_PetSlotButton",Growler.bar)
		Growler.bar.resetbtn:SetSize(16,16)
		Growler.bar.resetbtn:SetPoint("TOPRIGHT",Growler.bar,"TOPRIGHT",-10,-10)
		Growler.bar.resetbtn.texture_up = "Interface\\BUTTONS\\UI-RotationRight-Button-Up"
		Growler.bar.resetbtn.texture_down = "Interface\\BUTTONS\\UI-RotationRight-Button-Down"
		Growler.SetTexture(Growler.bar.resetbtn.texture_up,Growler.bar.resetbtn)
		Growler.bar.resetbtn.texture:SetPoint("TOPLEFT",Growler.bar.resetbtn,"TOPLEFT",-6,6)
		Growler.bar.resetbtn.texture:SetPoint("BOTTOMRIGHT",Growler.bar.resetbtn,"BOTTOMRIGHT",6,-6)
		Growler.bar.resetbtn:RegisterForClicks("LeftButtonUp","LeftButtonDown")
		Growler.bar.resetbtn:SetScript("OnClick",function(self,button,down)
			if button == "LeftButton" then
				if down then
					Growler.bar.resetbtn.texture:SetTexture(Growler.bar.resetbtn.texture_down)
				else
					Growler.bar.resetbtn.texture:SetTexture(Growler.bar.resetbtn.texture_up)
					Growler.bar.ResetPos(true)
					Growler.bar.SavePos()
				end
			end
		end)
		Growler.bar.resetbtn.update = function()
		end
		
		Growler.bar.lockbtn = CreateFrame("BUTTON","GrowlerBar_Lockbutton",Growler.bar)
		Growler.bar.lockbtn:SetSize(20,32)
		Growler.bar.lockbtn:SetPoint("RIGHT",Growler.bar,"RIGHT",-35,0)
		Growler.bar.lockbtn.texture_up = "Interface\\BUTTONS\\UI-Button-KeyRing"
		Growler.bar.lockbtn.texture_down = "Interface\\BUTTONS\\UI-Button-KeyRing-Down"
		Growler.bar.lockbtn.texture_disabled = ""
		Growler.SetTexture(Growler.bar.lockbtn.texture_down,Growler.bar.lockbtn)
		Growler.bar.lockbtn.texture:SetPoint("TOPLEFT",Growler.bar.lockbtn,"TOPLEFT",0,2)
		Growler.bar.lockbtn.texture:SetPoint("BOTTOMRIGHT",Growler.bar.lockbtn,"BOTTOMRIGHT",16,-23)
		Growler.bar.lockbtn:RegisterForClicks("LeftButtonUp")
		Growler.bar.lockbtn:SetScript("OnMouseUp",function(self,button)
			if button == "LeftButton" then
				PlaySoundKitID(8939)
				if Growler.bar.movable then 
					Growler.bar:SetBackdropBorderColor(1,1,1,1)	
					Growler.bar.lockbtn.texture:SetTexture(Growler.bar.lockbtn.texture_down)
					Growler.bar.movable = false
				else
					Growler.bar:SetBackdropBorderColor(0.7,1,0.7,1)
					Growler.bar.lockbtn.texture:SetTexture(Growler.bar.lockbtn.texture_up)
					Growler.bar.movable = true
				end
			end
		end)
		Growler.bar.lockbtn.update = function()
		end
		
		Growler.bar.petslotbtn = CreateFrame("BUTTON","GrowlerBar_PetSlotButton",Growler.bar)
		Growler.bar.petslotbtn:SetSize(20,32)
		Growler.bar.petslotbtn:SetPoint("RIGHT",Growler.bar,"RIGHT",-60,0)
		Growler.bar.petslotbtn.texture_up = "Interface\\BUTTONS\\UI-MicroButton-Bug-Up"
		Growler.bar.petslotbtn.texture_down = "Interface\\BUTTONS\\UI-MicroButton-Bug-Down"
		Growler.bar.petslotbtn.texture_disabled = "Interface\\BUTTONS\\UI-MicroButton-Bug-Up"
		Growler.SetTexture(Growler.bar.petslotbtn.texture_disabled,Growler.bar.petslotbtn)
		Growler.bar.petslotbtn.texture:SetPoint("TOPLEFT",Growler.bar.petslotbtn,"TOPLEFT",0,23)
		Growler.bar.petslotbtn.texture:SetPoint("BOTTOMRIGHT",Growler.bar.petslotbtn,"BOTTOMRIGHT",0,-2)
		Growler.bar.petslotbtn:RegisterForClicks("LeftButtonUp")
		Growler.bar.petslotbtn:SetScript("OnMouseUp",function(self,button)
			if button == "LeftButton" then
				local activeslot = Growler.GetActivePetSlot()
				if activeslot ~= GrowlerDB.options.activepetslot then
					Growler.SetActivePetSlot()
				end
			end
		end)
		Growler.bar.petslotbtn.update = function()
			if InCombatLockdown() then
				Growler.bar.petslotbtn.texture:SetDesaturated(1)
			else
				local activeslot = Growler.GetActivePetSlot()
				if activeslot == GrowlerDB.options.activepetslot then
					Growler.bar.petslotbtn.texture:SetDesaturated(nil)
					Growler.bar.petslotbtn.texture:SetTexture(Growler.bar.petslotbtn.texture_down)
				elseif activeslot == 0 then
					Growler.bar.petslotbtn.texture:SetDesaturated(1)
					Growler.bar.petslotbtn.texture:SetTexture(Growler.bar.petslotbtn.texture_up)
				else
					Growler.bar.petslotbtn.texture:SetDesaturated(nil)
					Growler.bar.petslotbtn.texture:SetTexture(Growler.bar.petslotbtn.texture_up)
				end
			end
		end
		
		Growler.bar.update = function()
			Growler.bar.resetbtn.update()
			Growler.bar.lockbtn.update()
			Growler.bar.petslotbtn.update()
		end
		
		Growler.bar.SavePos = function()
			local point, relativeTo, relativePoint, xOfs, yOfs = Growler.bar:GetPoint()
			GrowlerDB.options.point, GrowlerDB.options.relativeto, GrowlerDB.options.relativepoint, GrowlerDB.options.pos_x, GrowlerDB.options.pos_y = point, relativeto, relativePoint, xOfs, yOfs
		end
		Growler.bar.ResetPos = function(force)
			if not InCombatLockdown() then
				local point, relativeto, relativepoint, pos_x, pos_y = "CENTER", World, "CENTER", 0, -150
				if GrowlerDB.options.savepos and force ~= true then
					point, relativeto, relativepoint, pos_x, pos_y = GrowlerDB.options.point, GrowlerDB.options.relativeto, GrowlerDB.options.relativepoint, GrowlerDB.options.pos_x, GrowlerDB.options.pos_y
				end
				Growler.bar:SetSize(80 + (tablesize(Growler.btn) * (btnSize+10)) - 10,btnSize+20)
				Growler.bar:SetMovable(true)
				Growler.bar:SetUserPlaced(false)
				Growler.bar:ClearAllPoints()
				Growler.bar:SetPoint(point,relativeto,relativepoint,pos_x,pos_y)
				Growler.bar:SetMovable(false)
				
				for k,btn in pairs(Growler.btn) do
					btn:ClearAllPoints()
					btn:SetPoint("LEFT",Growler.bar,"LEFT",(-btnSize)+5 + ((btnSize+5)*btn.barpos),0)
				end
			else
				Growler.msg("Cannot reset position in combat.",true)
			end
		end
		Growler.bar.ResetPos()
	end
	
	Growler.UpdateSI = function()
		local prior = 0
		local btn = nil
		for k,v in pairs(Growler.btn) do
			if v.active and v.priority > prior then
				prior = v.priority
				btn = v
			end
		end
		for k,v in pairs(Growler.btn) do
			if not v.active or v.priority < prior then
				v.si.hide()
			end
		end
		if prior > 0 and GrowlerDB.options.screenicons then
			if TimeSinceLastScreenIconUpdate > 2.5 then
				if btn.si.active then
					btn.si:SetAlpha(0.3)
					btn.si:SetSize(siSize*0.9,siSize*0.9)
					btn.si.active = false
				else
					btn.si:SetAlpha(0.5)
					btn.si:SetSize(siSize,siSize)
					btn.si.active = true
				end
				TimeSinceLastScreenIconUpdate = 0
			end
		else
			TimeSinceLastScreenIconUpdate = 0
			for k,v in pairs(Growler.btn) do
				v.si.hide()
			end
		end
	end
	
	Growler.CreateSI = function(name,icon)
		local siName = "GrowlerSI_" .. name
		local si = CreateFrame("FRAME", siName, UIParent)
		si.name = siName
		si.lastupdate = 0
		si.active = false
		si:SetSize(siSize,siSize)
		si:SetPoint("CENTER",World,"CENTER",0,150)
		Growler.SetTexture(icon,si)
		si:SetAlpha(0)
		si.show = function()
			if GrowlerDB.options.screenicons then
				TimeSinceLastScreenIconUpdate = 0
				si:SetAlpha(0.5)
				si:SetSize(siSize,siSize)
				si.active = true
			end
		end
		si.hide = function()
			si.active = false
			si:SetAlpha(0)
		end
		
		return si
	end
	
	Growler.CreateButton = function(name,icon,priority,soundID,macro)
		if soundID == nil then soundID = 12867 end
		local btnName = "GrowlerBtn_" .. name
		local btn = CreateFrame("Button", btnName, Growler.bar, "SecureActionButtonTemplate")
		Growler.btn[name] = btn
		btn.name = btnName
		btn.lastupdate = 0
		btn.active = false
		btn.soundID = soundID
		btn.priority = priority
		btn:SetAttribute("type1","macro")
		btn:SetAttribute("macrotext1",macro)
		btn:SetSize(btnSize,btnSize)
		btn:SetAlpha(0.2)
		btn:SetClampedToScreen(true)
		Growler.SetTexture(icon,btn)
		btn.si = Growler.CreateSI("growl",icon)
		btn:RegisterForClicks()
		btn:RegisterForDrag("LeftButton")
		btn:SetScript("OnDragStart", function(self) Growler.bar.DragStart(self) end)
		btn:SetScript("OnDragStop", function(self) Growler.bar.DragStop(self) end)
		btn:SetScript("OnMouseUp", function(self, button)
			if button == "RightButton" then
			elseif button == "MiddleButton" then
			elseif button == "LeftButton" then
				if self.active and self == GrowlerBtn_call then
					if GrowlerDB.options.activepetslot == 0 then
						Growler.msg("You do not have an active pet slot saved. Summon a pet and click the save button.",true)
					else
						Growler_PetCalled = 0
					end
				end
			end
		end)
		btn.Show = function(icon,sound)
			btn.lastupdate = btn.lastupdate + 0.5
			if sound == nil then sound = btn.soundID end
			if icon ~= nil then
				if btn.texture:GetTexture()~=icon then
					btn.texture:SetTexture(icon)
					btn.si.texture:SetTexture(icon)
					ActionButton_HideOverlayGlow(btn)
					ActionButton_ShowOverlayGlow(btn)
					if GrowlerDB.options.sound then PlaySoundKitID(sound) end
				end
			end
			if not btn.active then
				btn.si.show()
				btn.active = true
				btn:SetAlpha(1)
				ActionButton_ShowOverlayGlow(btn)
				if GrowlerDB.options.sound and (icon == nil or btn.texture:GetTexture()==icon) then PlaySoundKitID(sound) end
				btn:RegisterForClicks("LeftButtonUp")
				btn.lastupdate = 0
			else
				if btn.lastupdate > 4.5 then
					ActionButton_HideOverlayGlow(btn)
					ActionButton_ShowOverlayGlow(btn)
					btn.lastupdate = 0
					if GrowlerDB.options.sound then PlaySoundKitID(38326) end
				end
			end
		end
		btn.Hide = function()
			if btn.active then
				btn.si.hide()
				btn.active = false
				ActionButton_HideOverlayGlow(btn)
				btn:SetAlpha(0.2)
				if GrowlerDB.options.sound then PlaySoundKitID(33338) end
				btn:RegisterForClicks()
			end
		end
		btn.barpos = tablesize(Growler.btn)
		Growler.bar.ResetPos()
	end
	
	Growler.Update = function(self, elapsed)
		TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed
		TimeSinceLastPetAttack = TimeSinceLastPetAttack + elapsed
		TimeSinceLastPlayerAttack = TimeSinceLastPlayerAttack + elapsed
		TimeSinceLastScreenIconUpdate = TimeSinceLastScreenIconUpdate + elapsed
		Growler_PetCalled = Growler_PetCalled + elapsed
		
		if TimeSinceLastUpdate > 0.5 then
			TimeSinceLastUpdate = 0			
			if GrowlerDB.options.enable then
				
				if not UnitIsDeadOrGhost("player") then
					local hasPet, isHunterPet = HasPetUI();
					local petHealth = UnitHealth("pet")
					local petHealthMax = UnitHealthMax("pet")
					local petDead = UnitIsDead("pet")
					for k,btn in pairs(Growler.btn) do btn.update(hasPet, isHunterPet, petDead, petHealth, petHealthMax) end
					Growler.UpdateSI()
				end
			elseif not GrowlerDB.options.enable then
				for k,btn in pairs(Growler.btn) do btn.Hide() end
			end
			
			Growler.bar.update()
		end
	end
	
	Growler.CreateButtons = function()
		Growler.CreateButton("growl",GetSpellIcon(2649),1,nil,"/petautocaston Growl\n/petautocastoff [@party1,exists][@raid1,exists] Growl")
		Growler.btn.growl.update = function(hasPet, isHunterPet)
			local autocastable, autostate = GetSpellAutocast("Growl")
			local inInstance, instanceType = IsInInstance()
			local _, instanceType, _, _, maxPlayers, _, _, _ = GetInstanceInfo()
			if PlayerHasSpell("Growl") and GrowlerDB.options.enable_growl and hasPet and isHunterPet and instanceType ~= "pvp" and ((IsInGroup() and autostate==true and maxPlayers > 1) or (((not IsInGroup() or maxPlayers==1) and autostate==false) and GrowlerDB.options.nonparty)) then
				Growler.btn.growl.Show()
			else
				Growler.btn.growl.Hide()
			end
		end
		
		Growler.CreateButton("call",GetSpellIcon(23498),5,nil,"")
		Growler.btn.call.updatemacro = function()
			if not InCombatLockdown() then
				local callpet = ""
				local revivepet = ""
				if GrowlerDB.options.enable_call then
					callpet = "\n/castsequence [nopet] reset=3 Call Pet " .. tostring(GrowlerDB.options.activepetslot) .. ", Revive Pet"
				end
				if GrowlerDB.options.enable_revive or GrowlerDB.options.enable_mend then
					revivepet = "/cast [pet] Revive Pet"
				end
				
				Growler.btn.call:SetAttribute("macrotext1",revivepet .. callpet)
			else
				Growler.msg("Cannot update this setting while in combat.",true)
			end
		end
		Growler.btn.call.updatemacro()
		Growler.btn.call.update = function(hasPet, isHunterPet, petDead, petHealth, petHealthMax)
			if GrowlerDB.options.enable_call and not hasPet and not IsFlying() and not UnitOnTaxi("player") and not IsFalling() and Growler_PetCalled > 3 then
				--local icon,_,_,_,_ = GetStablePetInfo(1)
				Growler.btn.call.Show(GetSpellIcon(23498),31754)
			else
				if PlayerHasSpell("Revive Pet") and GrowlerDB.options.enable_revive and (petDead or (not hasPet and not IsFlying() and not UnitOnTaxi("player") and not IsFalling() and GrowlerDB.options.enable_call and Growler_PetCalled <= 3)) then
					Growler.btn.call.Show(GetSpellIcon(982),38323)
				elseif PlayerHasSpell("Mend Pet") and GrowlerDB.options.enable_mend and hasPet and isHunterPet and ((petHealth/petHealthMax) < GrowlerDB.options.mend_threshhold) and SpellIsReady("Mend Pet") then
					Growler.btn.call.Show(GetSpellIcon(136),37656)
				else
					Growler.btn.call.Hide()
				end
			end
		end
		
		Growler.CreateButton("playdead",GetSpellIcon(209997),4,34153,"/cast Play Dead")
		Growler.btn.playdead.update = function(hasPet, isHunterPet, petDead)
			local isFeigning = UnitHasBuff("player","Feign Death")
			local playsDead = UnitHasBuff("pet","Play Dead")
			if PlayerHasSpell("Play Dead") and GrowlerDB.options.enable_playdead and hasPet and isHunterPet and not petDead and isFeigning and not playsDead and SpellIsReady(209997) then
				Growler.btn.playdead.Show(GetSpellIcon(209997),34153)
			elseif PlayerHasSpell("Play Dead") and GrowlerDB.options.enable_wakeup and hasPet and isHunterPet and not petDead and not isFeigning and playsDead and SpellIsReady(210000) then
				Growler.btn.playdead.Show(GetSpellIcon(210000),34152)
			else
				if not TipPlayDead and UnitLevel("player") == 110 and not PlayerHasSpell("Play Dead") then
					Growler.msg("You have not learned the spell 'Play Dead'. Buy the book from your class hall for extra functionality.")
					TipPlayDead = true
				end
				Growler.btn.playdead.Hide()
			end
		end
		
		Growler.CreateButton("passive",GetSpellIcon(6462),2,38600,"/petpassive")
		Growler.btn.passive.update = function(hasPet, isHunterPet, petDead)	
			if GrowlerDB.options.enable_passive and hasPet and isHunterPet and not petDead and TimeSinceLastPlayerAttack > 5 and TimeSinceLastPetAttack < 2 then
				for i=1,NUM_PET_ACTION_SLOTS do
					local name, _, _, _, isActive = GetPetActionInfo(i)
					if name == "PET_MODE_PASSIVE" and not isActive then
						if not isActive then
							Growler.btn.passive.Show()
						else
							Growler.btn.passive.Hide()							
						end
						break
					end
				end
				-- if not IsSpellActive("Passive",2) then
					-- GrowlerShow(GrowlerBtn_Passive)
				-- else
					-- GrowlerHide(GrowlerBtn_Passive)
				-- end
			else
				Growler.btn.passive.Hide()
			end
		end
		
		Growler.CreateButton("assist",GetSpellIcon(166615),3,38352,"/petassist\n/petattack [@target,harm,nodead,exists,combat]")		
		Growler.btn.assist.update = function(hasPet, isHunterPet, petDead, elapsed)
			if GrowlerDB.options.enable_assist and hasPet and isHunterPet and not petDead and TimeSinceLastPlayerAttack < 3 and InCombatLockdown() then
				for i=1,NUM_PET_ACTION_SLOTS do
					local name, _, _, _, isActive = GetPetActionInfo(i)
					if name == "PET_MODE_ASSIST" then
						if not isActive then
							Growler.btn.assist.Show()
						else
							Growler.btn.assist.Hide()							
						end
						break
					end
				end
			else
				Growler.btn.assist.Hide()
			end
		end
	end
	
	Growler.CreateOption = function(name,text,dbKey,frametype,insetlevel,handler,...)
		local args = {...}
		local template = "ChatConfigCheckButtonTemplate"
		local y_offset = -10
		if frametype == "Slider" then
			template = "OptionsSliderTemplate"
			y_offset = -30
		end
		
		Growler.Options[name] = CreateFrame(frametype, "GrowlerOptions" .. name, Growler.Options, template)
		Growler.Options[name].frametype = frametype
		Growler.Options[name].dbKey = dbKey		
		
		if frametype == "CheckButton" then
			Growler.Options[name]:SetChecked(GrowlerDB.options[dbKey])
		elseif frametype == "Slider" then
			Growler.Options[name]:SetMinMaxValues(args[1], args[2])
			Growler.Options[name]:SetValueStep(args[2]/10)
			getglobal(Growler.Options[name]:GetName() .. 'Low'):SetText(tostring(args[1]))
			getglobal(Growler.Options[name]:GetName() .. 'High'):SetText(tostring(args[2]))
			Growler.Options[name]:SetValue(GrowlerDB.options[dbKey])
		end
		
		getglobal(Growler.Options[name]:GetName() .. 'Text'):SetText(text)
		
		for k,opt in pairs(Growler.Options.UsedFields) do
			if opt.frametype == "CheckButton" then
				y_offset = y_offset - 25
			elseif opt.frametype == "Slider" then
				y_offset = y_offset - 55
			else
				y_offset = y_offset - 25
			end
		end
		
		Growler.Options[name]:ClearAllPoints()
		Growler.Options[name]:SetPoint("TOPLEFT", 10 + (insetlevel*20), y_offset)
		if handler then Growler.Options[name]:SetScript("OnClick",handler) end
		Growler.Options[name]:Show()
		Growler.Options.UsedFields[name] = Growler.Options[name]		
	end	
	
	Growler.CreateOptionsPanel = function()
		Growler.Options = CreateFrame("FRAME", "GrowlerOptions", Growler)
		Growler.Options.UsedFields = {}
		Growler.Options.name = "Growler"
		Growler.Options.okay = function()
			for k,opt in pairs(Growler.Options.UsedFields) do
				if opt.frametype == "CheckButton" then
					GrowlerDB.options[opt.dbKey] = opt:GetChecked()
				elseif opt.frametype == "Slider" then
					GrowlerDB.options[opt.dbKey] = opt:GetValue()					
				end
			end
			
			Growler.btn.call.updatemacro()
			Growler.bar.SavePos()
			Growler.bar.ResetPos()
		end		
		Growler.Options.cancel = function()
			for k,opt in pairs(Growler.Options.UsedFields) do
				if opt.frametype == "CheckButton" then
					opt:SetChecked(GrowlerDB.options[opt.dbKey])
				elseif opt.frametype == "Slider" then
					opt:SetValue(GrowlerDB.options[opt.dbKey])					
				end
			end
		end		
		Growler.Options.refresh = Growler.Options.cancel
		
		Growler.CreateOption("Enable","Enable buttons","enable","CheckButton",0,nil)
		Growler.CreateOption("Sound","Enable sound","sound","CheckButton",0,nil)
		Growler.CreateOption("NonParty","Alert about growl when not in a group","nonparty","CheckButton",0,nil)
		Growler.CreateOption("Notify","Notify group when someone uses growl","notifygroup","CheckButton",0,nil)
		Growler.CreateOption("ScreenIcons","Enable blinking icons at the center of the screen","screenicons","CheckButton",0,nil)
		Growler.CreateOption("Enable_growl","Give alerts about Growl","enable_growl","CheckButton",0,nil)
		Growler.CreateOption("Enable_call","Give alerts about Call Pet","enable_call","CheckButton",0,nil)
		Growler.CreateOption("Enable_revive","Give alerts about Revive Pet","enable_revive","CheckButton",0,function(self,button,down)
			if not Growler.Options.Enable_revive:GetChecked() then Growler.Options.Enable_mend:SetChecked(false) end
		end)
		Growler.CreateOption("Enable_mend","Give alerts about Mend Pet","enable_mend","CheckButton",1,function(self,button,down)
			if Growler.Options.Enable_mend:GetChecked() then Growler.Options.Enable_revive:SetChecked(true) end
		end)
		Growler.CreateOption("MendPet_Threshhold","Mend Pet Threshhold","mend_threshhold","Slider",1,nil,0.1,1)
		Growler.CreateOption("Enable_playdead","Give alerts about Play Dead","enable_playdead","CheckButton",0,nil)
		Growler.CreateOption("Enable_wakeup","Give alerts about Wake Up","enable_wakeup","CheckButton",0,nil)
		Growler.CreateOption("Enable_passive","Give alerts about putting your pet on passive","enable_passive","CheckButton",0,nil)
		Growler.CreateOption("Enable_assist","Give alerts about putting your pet on assist","enable_assist","CheckButton",0,nil)
		Growler.CreateOption("SavePos","Save the bar position between sessions","savepos","CheckButton",0,nil)		
			
		InterfaceOptions_AddCategory(Growler.Options)	
		Growler.Options.refresh()
	end
end

function Growler_OnLoad(self, event,...)
    self:RegisterEvent("ADDON_LOADED")
end

function Growler_OnEvent(self, event, ...)
	local isHunter = (tostring(UnitClass("player")) == "Hunter")
	if event == "ADDON_LOADED" then
		if ... == "Growler" then
			self:UnregisterEvent("ADDON_LOADED")
			self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
			InitiateDB()
			GrowlerSetup()
			
			if isHunter then
				self:UnregisterEvent("ADDON_LOADED")
				self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
				Growler.SetActivePetSlot(true)
				Growler.CreateBar()
				Growler.CreateButtons()
				Growler.CreateOptionsPanel()
				Growler.bar.ResetPos()
				self:SetScript("OnUpdate", Growler.Update)
			end
		end
	elseif event == "UNIT_SPELLCAST_SUCCEEDED" then
		GrowlerNotifyGroup(...)
	end
	
	if isHunter then
		if event == "COMBAT_LOG_EVENT_UNFILTERED" then
			GrowlerCheckCombatLogEvent(...)
		end
	end
end